function f=ConfidenceIntervalsForSimulations(y,p,d,hgrid,B,conf,n,bound)
hl=size(hgrid,1);
Ts=500;
f=zeros(hl,8);
T=size(y,1);
oGB=randi(T-p,T,B);
oGos=randn(Ts,B);
yd=demean(y,d);
paramsunr=OLS(yd,p);
for k=1:1:hl
    h=hgrid(k);
    g0=IRF(paramsunr,h,p);
    fcn=@(x)GBtest(y,p,d,h,x,oGB,conf,bound);
    g=search(fcn,g0,1,n);
    f(k,2)=g(1);
    f(k,4)=g(2);
    g=search(fcn,g0,-1,n);
    f(k,1)=g(1);
    f(k,3)=g(2);
    fcn=@(x)GospodinovTest(y,p,d,h,x,oGos,conf,bound);
    g=search(fcn,g0,1,n);
    f(k,6)=g(1);
    f(k,8)=g(2);
    g=search(fcn,g0,-1,n);
    f(k,5)=g(1);
    f(k,7)=g(2);
end
end

function v=search(fcn,g0,s,n)
    v=zeros(2,1);
    c=fcn(g0);
    if (c(1)==1) || (c(2)==1)
        display('error');
    end
    gl1=0; gl2=0; gh1=0; gh2=0;
    gcurrent=g0;
    r1=0; r2=0;
    while (r1==0) || (r2==0)
        gcurrent=gcurrent+s;
        c=fcn(gcurrent);
        if (c(1)==1) && (r1==0)
            r1=1;
            gl1=gcurrent-s;
            gh1=gcurrent;
        end
        if (c(2)==1) && (r2==0)
            r2=1;
            gl2=gcurrent-s;
            gh2=gcurrent;
        end
    end
    for k=1:1:n
        gcurrent=(gl1+gh1)/2;
        c=fcn(gcurrent);
        if c(1)==0
            gl1=gcurrent;
        else
            gh1=gcurrent;
        end
        gcurrent=(gl2+gh2)/2;
        c=fcn(gcurrent);
        if c(2)==0
            gl2=gcurrent;
        else
            gh2=gcurrent;
        end
    end
    v(1)=(gl1+gh1)/2; v(2)=(gl2+gh2)/2;
end

